DigestingMessageSigner (Bouncy Castle Library 1.52 API Specification)
Date: 2015-03-01

org.bouncycastle.pqc.crypto

## Class DigestingMessageSigner

- java.lang.Object
- - org.bouncycastle.pqc.crypto.DigestingMessageSigner

- All Implemented Interfaces:
    Signer

      public class DigestingMessageSigner
      extends java.lang.Object
      implements Signer

  Implements the sign and verify functions for a Signature Scheme which can use a hash function.

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `DigestingMessageSigner(MessageSigner messSigner, Digest messDigest)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `byte[]` | `generateSignature()` This function signs the message that has been updated, making use of the private key.
    `void` | `init(boolean forSigning, CipherParameters param)` Initialise the signer for signing or verification.
    `void` | `reset()` reset the internal state
    `void` | `update(byte b)` update the internal digest with the byte b
    `void` | `update(byte[] in, int off, int len)` update the internal digest with the byte array in
    `boolean` | `verify(byte[] signature)` This function verifies the signature of the message that has been updated, with the aid of the public key.
    `boolean` | `verifySignature(byte[] signature)` return true if the internal state represents the signature described in the passed in array.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### DigestingMessageSigner

          public DigestingMessageSigner(MessageSigner messSigner,
                                Digest messDigest)

  - ### Method Detail

    - #### init

          public void init(boolean forSigning,
                  CipherParameters param)

      Description copied from interface: `Signer`
      Initialise the signer for signing or verification.
      Specified by:
        `init` in interface `Signer`
      Parameters:
        `forSigning` - true if for signing, false otherwise
        `param` - necessary parameters.

    - #### generateSignature

          public byte[] generateSignature()

      This function signs the message that has been updated, making use of the private key.
      Specified by:
        `generateSignature` in interface `Signer`
      Returns:
        the signature of the message.

    - #### verify

          public boolean verify(byte[] signature)

      This function verifies the signature of the message that has been updated, with the aid of the public key.
      Parameters:
        `signature` - the signature of the message is given as a byte array.
      Returns:
        true if the signature has been verified, false otherwise.

    - #### update

          public void update(byte b)

      Description copied from interface: `Signer`
      update the internal digest with the byte b
      Specified by:
        `update` in interface `Signer`

    - #### update

          public void update(byte[] in,
                    int off,
                    int len)

      Description copied from interface: `Signer`
      update the internal digest with the byte array in
      Specified by:
        `update` in interface `Signer`

    - #### reset

          public void reset()

      Description copied from interface: `Signer`
      reset the internal state
      Specified by:
        `reset` in interface `Signer`

    - #### verifySignature

          public boolean verifySignature(byte[] signature)

      Description copied from interface: `Signer`
      return true if the internal state represents the signature described in the passed in array.
      Specified by:
        `verifySignature` in interface `Signer`